// editServices.js
var servicesChangesMade = false;

var servicesError = false;

// this is used to hold the Service Entry being edited/created
var tmpServiceEntry = new Array;

var protocolOptions = new Array;
protocolOptions['tcp'] = 0;
protocolOptions['udp'] = 1;
protocolOptions['icmp'] = 2;
protocolOptions['all'] = 3;
protocolOptions['other'] = 4;
protocolOptions[''] = 3;

var icmpTypeOptions = new Array;
icmpTypeOptions['any'] = 0;
icmpTypeOptions['echo-reply'] = 1;
icmpTypeOptions['pong'] = 2;
icmpTypeOptions['destination-unreachable'] = 3;
icmpTypeOptions['network-unreachable'] = 4;
icmpTypeOptions['host-unreachable'] = 5;
icmpTypeOptions['protocol-unreachable'] = 6;
icmpTypeOptions['port-unreachable'] = 7;
icmpTypeOptions['fragmentation-needed'] = 8;
icmpTypeOptions['source-route-failed'] = 9;
icmpTypeOptions['network-unknown'] = 10;
icmpTypeOptions['host-unknown'] = 11;
icmpTypeOptions['network-prohibited'] = 12;
icmpTypeOptions['host-prohibited'] = 13;
icmpTypeOptions['TOS-network-unreachable'] = 14;
icmpTypeOptions['TOS-host-unreachable'] = 15;
icmpTypeOptions['communication-prohibited'] = 16;
icmpTypeOptions['host-precedence-violation'] = 17;
icmpTypeOptions['precedence-cutoff'] = 18;
icmpTypeOptions['source-quench'] = 19;
icmpTypeOptions['redirect'] = 20;
icmpTypeOptions['network-redirect'] = 21;
icmpTypeOptions['host-redirect'] = 22;
icmpTypeOptions['TOS-network-redirect'] = 23;
icmpTypeOptions['TOS-host-redirect'] = 24;
icmpTypeOptions['echo-request'] = 25;
icmpTypeOptions['ping'] = 26;
icmpTypeOptions['router-advertisement'] = 27;
icmpTypeOptions['router-solicitation'] = 28;
icmpTypeOptions['time-exceeded'] = 29;
icmpTypeOptions['ttl-exceeded'] = 30;
icmpTypeOptions['ttl-zero-during-transit'] = 31;
icmpTypeOptions['ttl-zero-during-reassembly'] = 32;
icmpTypeOptions['parameter-problem'] = 33;
icmpTypeOptions['ip-header-bad'] = 34;
icmpTypeOptions['required-option-missing'] = 35;
icmpTypeOptions['timestamp-request'] = 36;
icmpTypeOptions['timestamp-reply'] = 37;
icmpTypeOptions['address-mask-request'] = 38;
icmpTypeOptions['address-mask-reply'] = 39;
icmpTypeOptions[''] = -1;

function protocolSelectOptions()
{
  var output = '';

  for (var option in protocolOptions)
  {
    if (option.length > 0)
    {
      output += '    <option value="' + option + '">' + option + '</option>\n';
    }
  }

  return output;
}

function icmpTypeSelectOptions()
{
  var output = '';

  for (var option in icmpTypeOptions)
  {
    if (option.length > 0)
    {
      output += '    <option value="' + option + '">' + option + '</option>\n';
    }
  }

  return output;
}

var serviceInfoprotoHandler = "onChange=\"var f=document.configF; if(f.proto.selectedIndex == " + protocolOptions['icmp'] + ") { f.icmpType.selectedIndex=" + icmpTypeOptions['any'] + "; f.dport.value=''; f.dport.disabled=true; f.sport.value=''; f.sport.disabled=true; f.protoValue.disabled = true; } else { f.icmpType.selectedIndex=-1; if (f.proto.selectedIndex == " + protocolOptions['other'] + ") { f.protoValue.disabled = false; f.dport.disabled=true; f.sport.disabled=true; f.protoValue.focus(); } else { f.protoValue.disabled = true; if (f.proto.selectedIndex == " + protocolOptions['tcp'] + " || f.proto.selectedIndex == " + protocolOptions['udp'] + ") { f.dport.disabled=false; f.sport.disabled=false; f.dport.focus(); } else { f.dport.disabled=true; f.sport.disabled=true; } } }\"";
var serviceInfoicmpHandler = "onChange=\"var f=document.configF; f.proto.selectedIndex=" + protocolOptions['icmp'] + "; f.dport.value=''; f.dport.disabled=true; f.sport.value=''; f.sport.disabled=true; f.protoValue.disabled = true;\"";

// define the <services> arguments
nameLookups['services'] = new Array;

createLookupEntry('services', 'name', 'Name', 'text', '', 'Specify the name of the service you are creating.');
createLookupEntry('services', 'proto', 'Protocol', 'mixed', protocolSelectOptions, 'Specify the Protocol of the packet you wish to match.  If a numeric value or not in the list, choose <i>other</i> and specify in the accompanying text field.', serviceInfoprotoHandler);
createLookupEntry('services', 'dport', 'Destination Port', 'text', '', 'Specify the Destination port or port range that this service uses.  A port range is defined as port:port.  Ex: 80:81 would specify that the destination goes to ports 80-81.  You can also specify port: and it will then go from port to 65535.  If you use :port then it will go from 0 to port.');
createLookupEntry('services', 'sport', 'Source Port', 'text', '', 'Specify the Source port or port range that this service uses.  A port range is defined as port:port.  Ex: 80:81 would specify that the source goes to ports 80-81.  You can also specify port: and it will then go from port to 65535.  If you use :port then it will go from 0 to port.');
createLookupEntry('services', 'icmpType', 'ICMP Type', 'select', icmpTypeSelectOptions, 'If proto = icmp, then specify the ICMP types to match against.', serviceInfoicmpHandler);
createLookupEntry('services', 'comment', 'Comment', 'textarea', '', 'Specify any comment about this service that will help remind you of what it is doing.');

function processEditServiceClick()
{
  var config = document.configF;

  if (config.service.selectedIndex == -1)
  {
    alert("You must select a Service to Edit!");
  }
  else
  {
    var service = config.service.options[config.service.selectedIndex].value;
    editServicesEntry(service);
  }
}

function processDeleteServiceClick()
{
  var config = document.configF;

  if (config.service.selectedIndex == -1)
  {
    alert("You must select a Service to Delete!");
  }
  else
  {
    var service = config.service.options[config.service.selectedIndex].value;
    deleteServicesEntry(service);
  }
}

function processImportServiceClick()
{
  var config = document.configF;

  if (config.masterServices.selectedIndex == -1)
  {
    alert("You must select at least one Service to Import!");
  }
  else
  {
    for (var i=0; i < config.masterServices.options.length; i++)
    {
      if (config.masterServices.options[i].selected)
      {
        var service = config.masterServices.options[i].value;
        importServiceEntry(service);
      }
    }
    
    displayServices();
  }
}

function displayServices()
{
  var content = getContent();

  if (! verifyChangesSaved())
  {
    return;
  }
  entryChangesMade = false;

  displayStatus("Editing Services...<br>\nSelect the Service from the list to Edit or Delete or click the <b>Create</b> button to create a new entry.", "info");

  // build up the form html to display the dataObj.services info in.
  var html = "";
  if (dataObj.masterServices != null && dataObj.masterServices['servicesOrder'].length > 0)
  {
    html += '  <table border="0" width="100%">\n';
    html += '    <tr>\n';
    html += '      <td width="50%" valign="top">\n';
    html += '        <center><b>Services Available to Import</b><br>\n';
    html += '        <select name="masterServices" multiple="1" size="10">\n';
    
    for (var serviceIndex in dataObj.masterServices['servicesOrder'])
    {
      var service = dataObj.masterServices['servicesOrder'][serviceIndex];
      html += '    <option value="' + service + '">' + service + '</option>\n';
    }
  
    html += '        </select><br>\n';
    html += '        ' + selectAllButton("masterServices") + '&nbsp;\n';
    html += '        ' + toggleSelectButton("masterServices") + '\n';
    html += '        <br><br>\n';
    html += '        <input type="button" name="import" value="Import" onClick="processImportServiceClick();">\n';
    html += '        </center>\n';
    html += '      </td>\n';
    html += '      <td width="50%" valign="top">\n';
  }
  html += '  <center><b>Services</b><br>\n';
  html += '  <select name="service" size="10">\n';

  for (var serviceIndex in dataObj.services['servicesOrder'])
  {
    var service = dataObj.services['servicesOrder'][serviceIndex];
    html += '    <option value="' + service + '">' + service + '</option>\n';
  }

  html += '  </select>\n';
  html += '  <br>\n';
  html += '  <input type="button" name="edit" value="Edit" onClick="processEditServiceClick();">&nbsp;\n';
  html += '  <input type="button" name="delete" value="Delete" onClick="processDeleteServiceClick();"><br>\n';
  html += '  <br>\n';
  html += '  <input type="button" name="create" value="Create" onClick="createServicesEntryScreen(\'\');">\n';
  html += '  </center>\n';
  
  if (dataObj.masterServices != null && dataObj.masterServices['servicesOrder'].length > 0)
  {
    html += '      </td>\n';
    html += '    </tr>\n';
    html += '  </table>\n';
  }

  content.innerHTML = html;
}

function displayServiceEntryEditable(name, prefixString, rowSpan)
{
  var output = '';
  try {
    var info = getLookupEntry('services', name);
  }
  catch (e) {
    return 'Error getting info! ' + e.message;
  }
  var handler = '';
  var result = info.handler.match(/^(.*onChange=".+)(")(.*)$/);
  if (result != null)
  {
    handler = result[1] + '; entryChangesMade=true;"' + result[3];
  }
  else
  {
    handler = 'onChange="entryChangesMade=true;"';
  }

  // create a table to hold the name and user interaction parts in.
  output += '    <td width="50%" valign="top"' + (arguments.length == 3 ? ' rowspan="' + rowSpan + '"' : '') + '>\n';  // start the td we are in.
  if (arguments.length >= 2)
  {
    if (prefixString.length > 0)
    {
      output += '      <center><b>' + prefixString + '</b></center>\n';
    }
  }
  output += '      <table width="100%" border="0" cellpadding="0" cellspacing="2">\n';
  output += '        <tr>\n';
  output += '          <td align="right" width="50%" valign="top"><a href="#" onClick="displayHelp(\'services\', \'' + name + '\'); return false;">' + info.displayString + '</a>&nbsp;</td>\n';
  output += '          <td align="left" width="50%">';

  if (info.type == "select")
  {
    output += '            <select name="' + name + '"' + handler + '>\n';
    // the options string is actually the function to call since this may be dynamic.
    var func = /^\s*function/;
    if (func.test(info.options))
    {
      output += info.options();
    }
    else
    {
      output += info.options;
    }
    output += '            </select>\n';
  }
  if (info.type == "text")
  {
    output += '            <input type="text" name="' + name + '" value=""' + handler + ' onKeyPress="entryChangesMade=true;">\n';
  }
  if (info.type == "textarea")
  {
    output += '            <textarea name="' + name + '"' + handler + ' onKeyPress="entryChangesMade=true;"></textarea>\n';
  }
  if (info.type == "multiselect")
  {
    output += '            <select name="' + name + '" multiple="multiple" size="5"' + handler + '>\n';
    // the options string is actually the function to call since this may be dynamic.
    var func = /^\s*function/;
    if (func.test(info.options))
    {
      output += info.options();
    }
    else
    {
      output += info.options;
    }
    output += '            </select>\n<br>\n';
    output += '            ' + selectAllButton(name) + '<br>\n';
    output += '            ' + toggleSelectButton(name) + '\n';
  }
  if (info.type == "mixed")
  {
    output += '            <select name="' + name + '"' + handler + '>\n';
    // the options string is actually the function to call since this may be dynamic.
    var func = /^\s*function/;
    if (func.test(info.options))
    {
      output += info.options();
    }
    else
    {
      output += info.options;
    }
    output += '            </select>\n';
    output += '            <input type="text" name="' + name + 'Value" value="" size="3" maxlength="3" onChange="entryChangesMade=true;" onKeyPress="entryChangesMade=true;">\n';
  }

  output += '          </td>\n';
  output += '        </tr>\n';
  output += '      </table>\n';
  output += '    </td>\n';  // close the td we are in.

  return output;
}

function displayServiceEntryInfoEntryScreen(mode, index)
{
  var content = getContent();
  var config = document.configF;
  var entry = (index == -1 ? new createServiceInfoEntry("","","","") : tmpServiceEntry['entry'].infos[index]);

  displayStatus((mode == "Create" ? "Creat" : mode) + "ing Port Mapping...", "info");

  servicesChangesMade = entryChangesMade;

  // build up the form html to display the port mapping info in.
  var html = "";
  html += '  <center><b>' + (mode == "Create" ? "Creat" : mode) + 'ing Port Mapping</b><br>\n';
  html += '  <table border="0" width="75%" cellpadding="0" cellspacing="2">\n';
  html += '    <tr>\n';
  html += displayServiceEntryEditable('proto');
  html += displayServiceEntryEditable('icmpType');
  html += '    </tr>\n';
  html += '    <tr>\n';
  html += displayServiceEntryEditable('dport');
  html += displayServiceEntryEditable('sport');
  html += '    </tr>\n';
  html += '  </table>\n';
  html += '  <br>\n';
  html += '  <input type="button" name="update" value="' + (mode == "Edit" ? "Update" : mode) + '" onClick="updateServiceEntryInfoEntry(\'' + mode + '\', \'' + index + '\');">';
  html += '  <input type="button" name="cancel" value="Cancel" onClick="entryChangesMade=servicesChangesMade; displayServicesEntryScreen(tmpServiceEntry[\'mode\'], tmpServiceEntry[\'origServiceName\']);"></center>\n';

  content.innerHTML = html;

  // initialize the settings.
  config.dport.value = entry.dport;
  config.sport.value = entry.sport;
  if (protocolOptions[entry.proto] == null)
  {
    config.proto.selectedIndex = protocolOptions['other'];
    config.protoValue.value = entry.proto;
  }
  else
  {
    config.proto.selectedIndex = protocolOptions[entry.proto];
  }
  config.icmpType.selectedIndex = icmpTypeOptions[entry.icmpType];
  if (config.proto.selectedIndex != protocolOptions['other'])
  {
    config.protoValue.disabled = true;
  }
  if (entry.proto != 'tcp' && entry.proto != 'udp')
  {
    config.dport.disabled = true;
    config.sport.disabled = true;
  }
}

function editServiceEntryInfoEntry(index)
{
  // make sure we preserve the service name and comment incase it changed.
  var config = document.configF;
  tmpServiceEntry['name'] = config.name.value;
  tmpServiceEntry['entry'].comment = config.comment.value;

  displayServiceEntryInfoEntryScreen('Edit', index);
}

function deleteServiceEntryInfoEntry(index)
{
  // make sure we preserve the service name and comment incase it changed.
  var config = document.configF;
  tmpServiceEntry['name'] = config.name.value;
  tmpServiceEntry['entry'].comment = config.comment.value;

  var result = confirm("Are you sure you want to Delete Port Mapping with index = '" + index + "'?");
  if (result == false)
  {
    return;
  }

  // verify the entry exists.
  if (tmpServiceEntry['entry'].infos[index] == null)
  {
    alert("Port Mapping with index = '" + index + "' does not exist to Delete!");
  }
  // delete the entry.
  else
  {
    delete tmpServiceEntry['entry'].infos[index];
    tmpServiceEntry['changed'] = true;
    entryChangesMade = true;
    displayServicesEntryScreen(tmpServiceEntry['mode'], tmpServiceEntry['origServiceName']);
  }
}

function createServicePortMappingScreen()
{
  // make sure we preserve the service name and comment incase it changed.
  var config = document.configF;
  tmpServiceEntry['name'] = config.name.value;
  tmpServiceEntry['entry'].comment = config.comment.value;

  displayServiceEntryInfoEntryScreen('Create', -1);
}

function updateServiceEntryInfoEntry(mode, index)
{
  var config = document.configF;
  var info = new createServiceInfoEntry((config.proto.selectedIndex != protocolOptions['other'] ? config.proto.options[config.proto.selectedIndex].value : config.protoValue.value), config.dport.value, config.sport.value, (config.icmpType.selectedIndex >= 0 ? config.icmpType.options[config.icmpType.selectedIndex].value : ""));
  if (info.proto == 'all')
  {
    info.proto = '';
  }
  if (mode == "Create")
  {
    tmpServiceEntry['entry'].infos.push(info);
  }
  else
  {
    tmpServiceEntry['entry'].infos[index] = info;
  }
  tmpServiceEntry['changed'] = true;
  entryChangesMade = true;
  displayServicesEntryScreen(tmpServiceEntry['mode'], tmpServiceEntry['origServiceName']);
}

function displayServiceEntry(index, color)
{
  var output = "";
  var mode = tmpServiceEntry['mode'];
  var info = tmpServiceEntry['entry'].infos[index];

  output += '          <tr bgColor="' + color + '" style="border: solid 1pt;">\n';
  output += '            <td align="center"><a href="#" onClick="editServiceEntryInfoEntry(' + index + '); return false;">Edit</a></td>\n';
  output += '            <td align="center">' + (info.proto.length == 0 ? '<b>all</b>' : fixupOutput(info.proto)) + '</td>\n';
  output += '            <td align="center">' + (info.dport.length == 0 && (info.proto == 'tcp' || info.proto == 'udp' || info.proto == '') ? '<b>any</b>' : fixupOutput(info.dport)) + '</td>\n';
  output += '            <td align="center">' + (info.sport.length == 0 && (info.proto == 'tcp' || info.proto == 'udp' || info.proto == '') ? '<b>any</b>' : fixupOutput(info.sport)) + '</td>\n';
  output += '            <td align="center">' + (info.icmpType.length == 0 && (info.proto == 'icmp' || info.proto == '') ? '<b>all</b>' : fixupOutput(info.icmpType)) + '</td>\n';
  output += '            <td align="center"><a href="#" onClick="deleteServiceEntryInfoEntry(' + index + '); return false;">Delete</a></td>\n';
  output += '          </tr>\n';
  return output;
}

function displayServicesEntryScreen(mode, service)
{
  var content = getContent();
  var config = document.configF;
  var services = dataObj.services;
  var entry = tmpServiceEntry['entry'];

  displayStatus(mode + (mode != "Create" ? "ing" : "") + " Service" + (mode != "Create" ? " '" + fixupOutput(service) + "'" : "") + "...", "info");

  // build up the form html to display the dataObj.services info in.
  var html = "";
  html += '  <input type="hidden" name="origService" value="' + tmpServiceEntry['origServiceName'] + '">\n';
  html += '  <center><b>' + mode + ' Service' + (mode != "Create" ? ' \'' + fixupOutput(service) + '\'' : '') + '</b><br>\n';
  html += '  <table border="0" width="75%" cellpadding="0" cellspacing="2">\n';
  html += '    <tr>\n';
  html += displayServiceEntryEditable('name');
  html += displayServiceEntryEditable('comment');
  html += '    </tr>\n';
  html += '    <tr>\n';
  html += '      <td colspan="2" align="center"><input type="button" name="createInfoEntry" value="Create Port Mapping" onClick="createServicePortMappingScreen()"><br><br>Port Mappings:</td>\n';
  html += '    </tr>\n';
  html += '    <tr>\n';
  html += '      <td colspan="2">\n';
  html += '        <table style="border-collapse: collapse; border: hidden;" cellpadding="0" cellspacing="2" width="100%">\n';
  html += '          <tr>\n';
  html += '            <th>&nbsp;</th><th align="center">Protocol</th><th align="center">d-port</th><th align="center">s-port</th><th align="center">icmp type</th><th>&nbsp;</th>\n';
  html += '          </tr>\n';
  var counter = true;
  for (var index in entry.infos)
  {
    var color = (counter ? "lightblue" : "white");
    html += displayServiceEntry(index, color);
    counter = !counter;
  }
  html += '        </table>\n';
  html += '      </td>\n';
  html += '    </tr>\n';
  html += '  </table>\n';
  html += '  <br>\n';
  html += '  <input type="button" name="update" value="Update" onClick="updateServicesEntry(\'' + mode + '\', \'' + service + '\');"></center>\n';

  content.innerHTML = html;

  // initialize the settings.
  config.name.value = tmpServiceEntry['name'];
  config.comment.value = entry.comment;
}

function editServicesEntry(service)
{
  tmpServiceEntry['name'] = service;
  tmpServiceEntry['origServiceName'] = service;
  tmpServiceEntry['entry'] = cloneArray(dataObj.services[service]);
  tmpServiceEntry['mode'] = 'Edit';
  tmpServiceEntry['changed'] = false;
  displayServicesEntryScreen('Edit', service);
}

function deleteServicesEntry(service)
{
  var services = dataObj.services;
  var result = confirm("Are you sure you want to Delete Service " + service + "'?");
  if (result == false)
  {
    return;
  }

  // verify the entry exists.
  if (services[service] == null)
  {
    alert("Service " + service + "' does not exist to Delete!");
  }
  // delete the entry.
  else
  {
    var deleteService = true;
    result = deleteInUsePaths('service', service);
    if (result == false)
    {
      return;
    }
    if (deleteService)
    {
      delete services[service];
      // find the service and remove from the servicesOrder array.
      for (var serviceIndex in services['servicesOrder'])
      {
        if (services['servicesOrder'][serviceIndex] == service)
        {
          delete services['servicesOrder'][serviceIndex];
        }
      }
      changesMade = true;
      entryChangesMade = false;
    }
  }

  // redisplay the Services screen.
  displayServices();
}

function createServicesEntryScreen(service)
{
  tmpServiceEntry['name'] = '';
  tmpServiceEntry['origServiceName'] = '';
  tmpServiceEntry['entry'] = new Object;
  tmpServiceEntry['entry'].comment = '';
  tmpServiceEntry['entry'].infos = new Array;
  tmpServiceEntry['mode'] = 'Create';
  tmpServiceEntry['changed'] = false;
  displayServicesEntryScreen('Create', '');
}

function updateServicesEntry(mode, service)
{
  var config = document.configF;
  var services = dataObj.services;
  var updateServiceName = false;
  var entry = tmpServiceEntry['entry'];

  if (mode != "Create")
  {
    if (config.origService.value != config.name.value)
    {
      // make sure this is not a duplicate service.
      for (var i=0; i < services['servicesOrder'].length; i++)
      {
        if (services['servicesOrder'][i] == config.name.value)
        {
          alert("You already have an service defined = '" + config.name.value + "'!");
          config.name.focus();
          return;
        }
      }
      updateServiceName = true;
    }
    entry.name = config.name.value;
  }
  else
  {
    // make sure this is not a duplicate service.
    for (var i=0; i < services['servicesOrder'].length; i++)
    {
      if (services['servicesOrder'][i] == config.name.value)
      {
        alert("You already have an service defined = '" + config.name.value + "'!");
        config.name.focus();
        return;
      }
    }
    entry.name = config.name.value;
  }
  var oldServiceName = config.origService.value;

  if (config.name.value.length == 0)
  {
    alert("You must specify the service name!");
    config.name.focus();
    return;
  }

  if (config.comment.value != entry.comment)
  {
    entryChangesMade = true;
    entry.comment = config.comment.value;
  }

  // make sure we have at least 1 info entry.
  if (entry.infos.length == 0)
  {
    alert("You must have at least 1 Port Info entry created!");
    servicesError = true;
  }

  if (servicesError)
  {
    // reset the error flag.
    servicesError = false;
  }
  else
  {
    if (mode == "Create")
    {
      services['servicesOrder'].push(entry.name);
    }
    else if (updateServiceName)
    {
      for (var i=0; i < services['servicesOrder'].length; i++)
      {
        if (services['servicesOrder'][i] == oldServiceName)
        {
          services['servicesOrder'][i] = entry.name;
          delete services[oldServiceName];
          break;
        }
      }

      // now update all the paths that referenced the old service Name to the new one.
      var paths = dataObj.paths;
      for (var serviceIndex in paths['serviceGroupsOrder'])
      {
        var serviceGroup = paths['serviceGroupsOrder'][serviceIndex];
        for (var zoneIndex in paths[serviceGroup]['zonePathOrder'])
        {
          var path = paths[serviceGroup]['zonePathOrder'][zoneIndex];
          for (var infoIndex in paths[serviceGroup][path])
          {
            var info = paths[serviceGroup][path][infoIndex];

            for (var serviceEntryIndex in info.service)
            {
              if (info.service[serviceEntryIndex] == oldServiceName)
              {
                paths[serviceGroup][path][infoIndex].service[serviceEntryIndex] = entry.name;
              }
            }
          }
        }
      }
    }
    if (entryChangesMade || updateServiceName || tmpServiceEntry['changed'])
    {
      changesMade = true;
      entryChangesMade = false;
      services[entry.name] = cloneArray(entry);
    }
    displayServices();
  }
}

function importServiceEntry(service)
{
  var services = dataObj.services;
  var masterServices = dataObj.masterServices;
  
  // verify the entry exists.
  if (masterServices[service] == null)
  {
    alert("Service '" + service + "' does not exist to Import!");
    return;
  }
  if (services[service] != null)
  {
    alert("Service '" + service + "' already exists!  Can not be imported again.");
    return;
  }
  // import the entry.
  services['servicesOrder'].push(service);  // add to servicesOrder array.
  services[service] = cloneArray(masterServices[service]);
  
  changesMade = true;
  entryChangesMade = false;
}
